'$sim
$regfile = "89s8252.dat"
'$regfile = "89c2051.dat"
$baud = 19200
$crystal = 22118400

' In programs qdpdu1a.bas in qdpdu2a.bas we did not bother with
'   Siemens C35i's opinion about our commands. He might be happy with it
'   or not. If we listen to the answers from C35i, we know, how
'   successfull have we send the message.

' This program does the same as previos two, but it also
' listens the answers from C35i. With simple Input bascom statements
' I did not succseed it. I wrote an Serial Interrupt routine, which
' intercepts every character read on RS232 and puts it at the end
' of an 16 bytes big area named XX1(1-16). When a character is read,
' the routine shifts all characters one byte to the left, and puts
' the newly read character at last position, XX1(16).
'
' For this purpose the crystal 22118400 Hz is mandatory to make the
' microprocessor fast enough to catch every character.

' In this program, program does not check the answers, in only
' displays the answer on LCD and give us some seconds of time
' to visualy check it, just to be sure, how it works. In your program
' you shall probably change this part of code, so that your program
' can be shure, if sending of messages is doing good.

' For display on LCD soubroutine Prikazi (= Show) is responsible. It
' displays the input area XX1(1) to XX1(16) in first line of LCD
' in character format and XX1(9) to XX1(16) in hex notation, so we
' can see also the characters <cr> <nl> and others.

Dim Xx1(16) As Byte
' druga vrstica LCD-a za prikaz zadnjih 8 znakov v hex obliki
Dim Xx2(16) As Byte

Dim I As Byte
Dim J As Byte
Dim Dolzstev As Byte
Dim Dolzspor As Byte
Dim Dolztele As Byte
Dim K1 As Byte
Dim K2 As Byte
Dim K As Byte

Declare Sub Prikazi
Print ;

On Serial Serial_interrupt_rtn
Enable Serial
Enable Interrupts

Cls
'  we put blanks in input area:
For I = 1 To 16
  Xx1(i) = 32
  ' damo zaetne vrednosti, 8 znakov presledek
Next
' wait a litle
Wait 5
' We send AT command
' Because interrupt routine and Print statements can not be in
' effect contemporaneously (or I do not know how to do it) I disabled
' Serial interrupt rutine before each Print statement and enabled after.

Disable Serial
Set Scon.1
 Print "AT"
Reset Scon.1
Enable Serial
Waitms 230
Prikazi
'  The answer on LCD should be   x A T           O  K
'                                    54 0d 0d 0a 4f 4b 0d 0a
'  10 seconds for visual check on LCD
Wait 10
' We send AT+CMGF? command
' The command is realy the question: what kind of SMS format do you support?

Disable Serial
Set Scon.1
 Print "AT+CMGF?"
Reset Scon.1
Enable Serial
Waitms 230
Prikazi
' The answer od LCD should be
'    . . + C M F G :   0             O  K
'                        0d 0d 0d 0a 4f 4b 0d 0a
' The answer 0 means: I know only PDU mode

Wait 5
' //////////////////////////////////////////
' we find out the length of telephone number
I = 0
Do
   J = Lookup(i , Telno)
   Incr I
Loop Until J = 0
Dolzstev = I - 1
' we save it into Dolzstev
'///////////////////////////////////////////
' we find out the length of messagetext
I = 0
Do
   J = Lookup(i , Sporocilo)
   Incr I
Loop Until J = 0
Dolzspor = I - 1
' we save it into Dolzspor
'////////////////////////////////////////////
' out of this two length infos we calculate the length
' of the telegram for the AT+CMGS=xx command

I = Dolzstev Mod 2
J = Dolzstev / 2
I = I + J
Dolztele = 7 + I
I = Dolzspor Mod 8
J = Dolzspor / 8
J = J * 7
J = J + I
Dolztele = Dolztele + J
Disable Serial
Set Scon.1
Print "AT+CMGS=" ; Dolztele
Reset Scon.1
Enable Serial
' /////////////////////////////////////////////
Waitms 250
Prikazi
' The answer od LCD should be
'        . A T +  C M G S = 2 2       >
'                         3d32320d0d0a3e20
Wait 5
' /////////////////////////////////////////////
'   Now we begin to send telegram
'   Prefix first:
Disable Serial
Set Scon.1
Print "000100";

'   It follows the recipients telephone

Printhex Dolzstev;
Print "91";
For I = 0 To Dolzstev Step 2
   J = I + 1
   If J >= Dolzstev Then
      Print "F";
   Else
      K1 = Lookup(j , Telno)
      Print Chr(k1);
   End If
   K1 = Lookup(i , Telno)
   Print Chr(k1);
Next

'   some attributes
Print "0000";
'   It follows the message text compressed according the
'        http://www.dreamfabric.com/sms/hello.html
Printhex Dolzspor;
I = 0
J = 1
Do
   K1 = Lookup(i , Sporocilo )
   K2 = Lookup(j , Sporocilo)
   K = I Mod 8
   Shift K1 , Right , K
   K = 7 - K
   Shift K2 , Left , K
   K1 = K1 + K2
   Printhex K1;
   Incr I
   Incr J
   If K = 1 Then
        Incr J
        Incr I
   End If
Loop Until I >= Dolzspor
'  We conclude with <ctrl-z>
Print Chr(26);
' //////////////////////////////////////////
Reset Scon.1
Enable Serial
' To process the SMS we give to C35i some time:
Wait 5
Prikazi
' The answer od LCD should be
'               25        O K
'                 0d0a0d0a4f4b0d0a
' 25 is the number of C35i's internal counter of send SMS, It should
'    rise for 1 each sent SMS
'    cruisal is, if the answer contains OK
'    It might be also
'         799d80e . . E R R O R . .
'                   0A4552524F520D0A
'    Which means, something went wrong, message is not send
End

' ////////////////Serial interrupt routine ////////////////
Dim Swrk As Byte
Dim Si As Byte
Dim Sj As Byte
Serial_interrupt_rtn:
Disable Serial
' we move all characters one place to the left (on LCD)
' and we put the newly read character at the end
Swrk = Inkey()
Scon.1 = 0
For Si = 1 To 15
    Sj = Si + 1
    Xx1(si) = Xx1(sj)
Next
Xx1(16) = Swrk
Enable Serial
Return
' ////////////////////////////////////////////////////////

'/////////////Subroutine to display XX1 area on LCD///////////

Sub Prikazi
   Locate 1 , 1
   For I = 1 To 16
     Lcd Chr(xx1(i)) ;
   Next
   For I = 9 To 16
     J = I - 9
     J = J * 2
     J = J + 1
     Xx2(j) = Xx1(i) / 16
     Xx2(j) = Lookup(xx2(j) , Hextab)
     Incr J
     Xx2(j) = Xx1(i) / 16
     Xx2(j) = Xx2(j) * 16
     Xx2(j) = Xx1(i) - Xx2(j)
     Xx2(j) = Lookup(xx2(j) , Hextab)
   Next
   Locate 2 , 1
   For I = 1 To 16
     Lcd Chr(xx2(i)) ;
   Next
End Sub

Hextab:
Data "0123456789ABCDEF"
Telno:
' Telephone no
Data "38641123456"
Sporocilo:
' Message text
Data "Hello! This test report was send to you by my at89s8252. Sincerely"